//+------------------------------------------------------------------+
//|                                            Daily_Range_Stats.mq4 |
//|                                       Copyright @ Dariusz Surdel |
//|                                   http://www.Fx-NVATC.comeze.com |
//+------------------------------------------------------------------+
#property copyright "Copyright @ Dariusz Surdel"
#property link      "http://www.Fx-NVATC.comeze.com" 
#property indicator_chart_window


extern int DisplayCorner = 2;
extern int Last_Week_y  = 21;
extern int This_Week_y  = 9;
extern int Day_Label_x  = 500;//563
extern color Color = Orange;

double DR_Last_Mon,DR_Last_Tue,DR_Last_Wed,DR_Last_Thu,DR_Last_Fri,
       DR_This_Mon,DR_This_Tue,DR_This_Wed,DR_This_Thu,DR_This_Fri,
       WR_This_Week,WR_Last_Week,Factor;
int    Mon_Shift,Tue_Shift,Wed_Shift,Thu_Shift,Fri_Shift;

string text;

int init(){
  
  ObjectCreate("DR_Last_Mon", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_Last_Mon", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_Last_Mon", OBJPROP_XDISTANCE, Day_Label_x);
  ObjectSet("DR_Last_Mon", OBJPROP_YDISTANCE, Last_Week_y);
  
  ObjectCreate("DR_Last_Tue", OBJ_LABEL, 0, 0, 0);
  ObjectSet("DR_Last_Tue", OBJPROP_CORNER, DisplayCorner);  // 
  ObjectSet("DR_Last_Tue", OBJPROP_XDISTANCE, Day_Label_x+50);
  ObjectSet("DR_Last_Tue", OBJPROP_YDISTANCE, Last_Week_y);
  
  ObjectCreate("DR_Last_Wed", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_Last_Wed", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_Last_Wed", OBJPROP_XDISTANCE, Day_Label_x+100);
  ObjectSet("DR_Last_Wed", OBJPROP_YDISTANCE, Last_Week_y);
  
  ObjectCreate("DR_Last_Thu", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_Last_Thu", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_Last_Thu", OBJPROP_XDISTANCE, Day_Label_x+150);
  ObjectSet("DR_Last_Thu", OBJPROP_YDISTANCE, Last_Week_y);
  
  ObjectCreate("DR_Last_Fri", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_Last_Fri", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_Last_Fri", OBJPROP_XDISTANCE, Day_Label_x+200);
  ObjectSet("DR_Last_Fri", OBJPROP_YDISTANCE, Last_Week_y);
   
  ObjectCreate("DR_This_Mon", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_This_Mon", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_This_Mon", OBJPROP_XDISTANCE, Day_Label_x);
  ObjectSet("DR_This_Mon", OBJPROP_YDISTANCE, This_Week_y);
  
  ObjectCreate("DR_This_Tue", OBJ_LABEL, 0, 0, 0);
  ObjectSet("DR_This_Tue", OBJPROP_CORNER, DisplayCorner);  // 
  ObjectSet("DR_This_Tue", OBJPROP_XDISTANCE, Day_Label_x+50);
  ObjectSet("DR_This_Tue", OBJPROP_YDISTANCE, This_Week_y);
  
  ObjectCreate("DR_This_Wed", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_This_Wed", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_This_Wed", OBJPROP_XDISTANCE, Day_Label_x+100);
  ObjectSet("DR_This_Wed", OBJPROP_YDISTANCE, This_Week_y);
  
  ObjectCreate("DR_This_Thu", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_This_Thu", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_This_Thu", OBJPROP_XDISTANCE, Day_Label_x+150);
  ObjectSet("DR_This_Thu", OBJPROP_YDISTANCE, This_Week_y);
  
  ObjectCreate("DR_This_Fri", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("DR_This_Fri", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("DR_This_Fri", OBJPROP_XDISTANCE, Day_Label_x+200);
  ObjectSet("DR_This_Fri", OBJPROP_YDISTANCE, This_Week_y); 
  
  ObjectCreate("Monday", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Monday", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Monday", OBJPROP_XDISTANCE, Day_Label_x);
  ObjectSet("Monday", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Monday","Mon",9, "Berlin Sans FB", Color);  
  
  ObjectCreate("Tuesday", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Tuesday", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Tuesday", OBJPROP_XDISTANCE, Day_Label_x+50);
  ObjectSet("Tuesday", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Tuesday","Tue",9, "Berlin Sans FB", Color); 
  
  ObjectCreate("Wednesday", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Wednesday", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Wednesday", OBJPROP_XDISTANCE, Day_Label_x+100);
  ObjectSet("Wednesday", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Wednesday","Wed",9, "Berlin Sans FB", Color);  
  
  ObjectCreate("Thursday", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Thursday", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Thursday", OBJPROP_XDISTANCE, Day_Label_x+150);
  ObjectSet("Thursday", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Thursday","Thu",9, "Berlin Sans FB", Color);     

  ObjectCreate("Friday", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Friday", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Friday", OBJPROP_XDISTANCE, Day_Label_x+200);
  ObjectSet("Friday", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Friday","Fri",9, "Berlin Sans FB", Color);
    
  ObjectCreate("Last", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Last", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Last", OBJPROP_XDISTANCE, Day_Label_x-72);
  ObjectSet("Last", OBJPROP_YDISTANCE, Last_Week_y); 
  ObjectSetText("Last","Last Week",9, "Berlin Sans FB", Color);  
  
  ObjectCreate("This", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("This", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("This", OBJPROP_XDISTANCE, Day_Label_x-72);
  ObjectSet("This", OBJPROP_YDISTANCE, This_Week_y); 
  ObjectSetText("This","This Week",9, "Berlin Sans FB", Color);  
  
  ObjectCreate("Daily Range", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Daily Range", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Daily Range", OBJPROP_XDISTANCE, Day_Label_x-72);
  ObjectSet("Daily Range", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Daily Range","Daily Range",9, "Berlin Sans FB", Color); 
   
  ObjectCreate("WR_Last_Week", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("WR_Last_Week", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("WR_Last_Week", OBJPROP_XDISTANCE, Day_Label_x+250);
  ObjectSet("WR_Last_Week", OBJPROP_YDISTANCE, Last_Week_y); 
  
  ObjectCreate("WR_This_Week", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("WR_This_Week", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("WR_This_Week", OBJPROP_XDISTANCE, Day_Label_x+250);
  ObjectSet("WR_This_Week", OBJPROP_YDISTANCE, This_Week_y); 
  
  ObjectCreate("Weekly Range", OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Weekly Range", OBJPROP_CORNER, DisplayCorner);
  ObjectSet("Weekly Range", OBJPROP_XDISTANCE, Day_Label_x+250);
  ObjectSet("Weekly Range", OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Weekly Range","Weekly",9, "Berlin Sans FB", Color);           
  return(0);

}

int deinit(){
  ObjectDelete("DR_This_Mon");
  ObjectDelete("DR_This_Tue");
  ObjectDelete("DR_This_Wed");
  ObjectDelete("DR_This_Thu");
  ObjectDelete("DR_This_Fri");
  ObjectDelete("DR_Last_Mon");
  ObjectDelete("DR_Last_Tue");
  ObjectDelete("DR_Last_Wed");
  ObjectDelete("DR_Last_Thu");
  ObjectDelete("DR_Last_Fri");
  ObjectDelete("Monday");
  ObjectDelete("Tuesday");
  ObjectDelete("Wednesday");
  ObjectDelete("Thursday");
  ObjectDelete("Friday");
  ObjectDelete("Last"); 
  ObjectDelete("This"); 
  ObjectDelete("Daily Range"); 
  ObjectDelete("Weekly Range");    
  ObjectDelete("WR_This_Week");
  ObjectDelete("WR_Last_Week");   
  return(0);
}

int start(){ Comment(DayOfWeek());
//Last week
 if(DayOfWeek()==1)
  {
 Mon_Shift = 6;Tue_Shift = 5;Wed_Shift = 4;Thu_Shift = 3;Fri_Shift = 2;
 DR_Last_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_Last_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_Last_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_Last_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_Last_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }
  
 if(DayOfWeek()==2)
  {
 Mon_Shift = 7;Tue_Shift = 6;Wed_Shift = 5;Thu_Shift = 4;Fri_Shift = 3;
 DR_Last_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_Last_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_Last_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_Last_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_Last_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }
  
 if(DayOfWeek()==3)
  {
 Mon_Shift = 8;Tue_Shift = 7;Wed_Shift = 6;Thu_Shift = 5;Fri_Shift = 4; 
 DR_Last_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_Last_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_Last_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_Last_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_Last_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }
  
 if(DayOfWeek()==4)
  {
 Mon_Shift = 9;Tue_Shift = 8;Wed_Shift = 7;Thu_Shift = 6;Fri_Shift = 5;
 DR_Last_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_Last_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_Last_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_Last_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_Last_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }
  
 if(DayOfWeek()==5||DayOfWeek()==6||DayOfWeek()==7)
  {
 Mon_Shift = 10;Tue_Shift = 9;Wed_Shift = 8;Thu_Shift = 7;Fri_Shift = 6; 
 DR_Last_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_Last_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_Last_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_Last_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_Last_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }


// This week
 if(DayOfWeek()==1)
  {
 Mon_Shift = 0;Tue_Shift = -1;Wed_Shift = -2;Thu_Shift = -3;Fri_Shift = -4;
 DR_This_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_This_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_This_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_This_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_This_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }  

 if(DayOfWeek()==2)
  {
 Mon_Shift = 1;Tue_Shift = 0;Wed_Shift = -2;Thu_Shift = -3;Fri_Shift = -4;
 DR_This_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_This_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_This_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_This_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_This_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }  

 if(DayOfWeek()==3)
  {
 Mon_Shift = 2;Tue_Shift = 1;Wed_Shift = 0;Thu_Shift = -3;Fri_Shift = -4;
 DR_This_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_This_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_This_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_This_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_This_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }   
 
 if(DayOfWeek()==4)
  {
 Mon_Shift = 3;Tue_Shift = 2;Wed_Shift = 1;Thu_Shift = 0;Fri_Shift = -4;
 DR_This_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_This_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_This_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_This_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_This_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }   

 if(DayOfWeek()==5||DayOfWeek()==6||DayOfWeek()==7)
  {
 Mon_Shift = 4;Tue_Shift = 3;Wed_Shift = 2;Thu_Shift = 1;Fri_Shift = 0;
 DR_This_Mon = NormalizeDouble((iHigh(NULL,1440,Mon_Shift)-iLow(NULL,1440,Mon_Shift))/Point,Digits);
 DR_This_Tue = NormalizeDouble((iHigh(NULL,1440,Tue_Shift)-iLow(NULL,1440,Tue_Shift))/Point,Digits);
 DR_This_Wed = NormalizeDouble((iHigh(NULL,1440,Wed_Shift)-iLow(NULL,1440,Wed_Shift))/Point,Digits);
 DR_This_Thu = NormalizeDouble((iHigh(NULL,1440,Thu_Shift)-iLow(NULL,1440,Thu_Shift))/Point,Digits);
 DR_This_Fri = NormalizeDouble((iHigh(NULL,1440,Fri_Shift)-iLow(NULL,1440,Fri_Shift))/Point,Digits);
  }  
 
 if(Digits==5||Digits==3) {Factor=10;}  else Factor=1;  
  text=DoubleToStr(DR_Last_Mon/Factor,0);                                                    // 
  ObjectSetText("DR_Last_Mon",text,9, "Berlin Sans FB", Color);
  
  text=DoubleToStr(DR_Last_Tue/Factor,0);                                                  // 
  ObjectSetText("DR_Last_Tue",text,9, "Berlin Sans FB", Color);
  
  text=DoubleToStr(DR_Last_Wed/Factor,0);                                                         // 
  ObjectSetText("DR_Last_Wed",text,9, "Berlin Sans FB", Color);  

  text=DoubleToStr(DR_Last_Thu/Factor,0);                                                         // 
  ObjectSetText("DR_Last_Thu",text,9, "Berlin Sans FB", Color);  
  
  text=DoubleToStr(DR_Last_Fri/Factor,0);                                                        // 
  ObjectSetText("DR_Last_Fri",text,9, "Berlin Sans FB", Color);
  
  text=DoubleToStr(DR_This_Mon/Factor,0);                                                   // 
  ObjectSetText("DR_This_Mon",text,9, "Berlin Sans FB", Color);
  
  text=DoubleToStr(DR_This_Tue/Factor,0);                                                 // 
  ObjectSetText("DR_This_Tue",text,9, "Berlin Sans FB", Color);
  
  text=DoubleToStr(DR_This_Wed/Factor,0);                                                        // 
  ObjectSetText("DR_This_Wed",text,9, "Berlin Sans FB", Color);  

  text=DoubleToStr(DR_This_Thu/Factor,0);                                                       // 
  ObjectSetText("DR_This_Thu",text,9, "Berlin Sans FB", Color);  
  
  text=DoubleToStr(DR_This_Fri/Factor,0);                                                       // 
  ObjectSetText("DR_This_Fri",text,9, "Berlin Sans FB", Color);
  
  WR_Last_Week=DR_Last_Mon+DR_Last_Tue+DR_Last_Wed+DR_Last_Thu+DR_Last_Fri;
  WR_This_Week=DR_This_Mon+DR_This_Tue+DR_This_Wed+DR_This_Thu+DR_This_Fri;
    
  text=DoubleToStr(WR_This_Week/Factor,0);                                                       // 
  ObjectSetText("WR_This_Week",text,9, "Berlin Sans FB", Color); 
  
  text=DoubleToStr(WR_Last_Week/Factor,0);                                                       // 
  ObjectSetText("WR_Last_Week",text,9, "Berlin Sans FB", Color);
        
  return(0);
   
}
//+------------------------------------------------------------------+